
!Duration methodsFor: '*pharoDurationPatch' stamp: 'sebastiansastre 9/29/2011 17:04'!
asDays

	^ self days! !

!Duration methodsFor: '*pharoDurationPatch' stamp: 'sebastiansastre 9/29/2011 17:04'!
asHours
 	"Answer the value of this duration in hours."
 
 	^ self asDays * 24 + self lastDayHours ! !

!Duration methodsFor: '*pharoDurationPatch' stamp: 'sebastiansastre 9/29/2011 17:00'!
asMinutes
 	"Answer the value of this duration in minutes."
 
 	^ self asHours * 60
 ! !

!Duration methodsFor: '*pharoDurationPatch' stamp: 'sebastian.sastre 3/11/2011 12:72'!
lastDayHours
	"Answers the value of hours of the last (or only) day of this duration."
 
 	^ (seconds rem: SecondsInDay) quo: SecondsInHour
 ! !

!Duration methodsFor: '*pharoDurationPatch' stamp: 'sebastian.sastre 3/11/2011 12:72'!
lastDayMinutes
	"Answers the value of minutes of the last (or only) day of this duration."
 
 	^ (seconds rem: SecondsInHour) quo: SecondsInMinute
 ! !

!Duration methodsFor: '*pharoDurationPatch' stamp: 'sebastian.sastre 3/11/2011 12:72'!
lastDaySeconds
	"Answers the value of seconds of the last (or only) day of this duration."
 
 	^ (seconds rem: SecondsInMinute)! !

!Duration methodsFor: '*pharoDurationPatch' stamp: 'sebastiansastre 9/29/2011 17:07'!
printOn: aStream
	"Format as per ANSI 5.8.2.16: [-]D:HH:MM:SS[.S]" 	| d h m s n |
	d := self days abs.
	h := self hours abs.
	m := self minutes abs.
 	s := self lastDaySeconds abs truncated.
	n := self nanoSeconds abs. 	self negative ifTrue: [ aStream nextPut: $- ].
	d printOn: aStream. aStream nextPut: $:.
	h < 10 ifTrue: [ aStream nextPut: $0. ].
	h printOn: aStream. aStream nextPut: $:.
	m < 10 ifTrue: [ aStream nextPut: $0. ].
	m printOn: aStream. aStream nextPut: $:.
	s < 10 ifTrue: [ aStream nextPut: $0. ].
	s printOn: aStream.
	n = 0 ifFalse:
		[ | z ps |
		aStream nextPut: $..
		ps := n printString padded: #left to: 9 with: $0. 
		z := ps findLast: [ :c | c asciiValue > $0 asciiValue ].
		ps from: 1 to: z do: [ :c | aStream nextPut: c ] ].
! !
